/*
 * Copyright (c) 2019 Stefan Strobel <stefan.strobel@shimatta.net>
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

/**
 * @file    shellmatta_escape.h
 * @brief   functions to parse and generate escape sequences
 * @author  Stefan Strobel <stefan.strobel@shimatta.net>
 */

/**
 * @addtogroup shellmatta_escape
 * @{
 */
#ifndef _SHELLMATTA_ESCAPE_H_
#define _SHELLMATTA_ESCAPE_H_

#include "shellmatta.h"
#include <stdint.h>

shellmatta_retCode_t escape_processArrowKeys(shellmatta_instance_t *inst);
void escape_handleSequence(shellmatta_instance_t *inst, char data);

#endif

/** @} */

