#include "test/framework/catch.hpp"
#include "src/shellmatta_utils.c"
#include <string.h>

static uint32_t write_callCnt = 0u;
static const char *write_data;
static uint32_t write_length;

static shellmatta_retCode_t writeFct(const char* data, uint32_t length)
{
    write_callCnt ++;
    write_data = data;
    write_length = length;
    return SHELLMATTA_OK;
}

TEST_CASE( "shellmatta_writeEcho echo enabled" ) {

    shellmatta_instance_t inst;
    char buffer[20];
    char dummyData[29];

    inst.buffer = buffer;
    inst.bufferSize = 20;
    inst.cursor = 10;
    inst.inputCount = 10;
    inst.echoEnabled = true;

    inst.write = writeFct;

    write_callCnt = 0u;
    write_data = 0u;
    write_length = 0u;

    utils_writeEcho(&inst, (char*)&dummyData, sizeof(dummyData));

    CHECK( write_callCnt == 1u );
    CHECK( write_data == (char*)&dummyData );
    REQUIRE( write_length == sizeof(dummyData));
}

TEST_CASE( "shellmatta_writeEcho echo disabled" ) {

    shellmatta_instance_t inst;
    char buffer[20];
    char dummyData[29];

    inst.buffer = buffer;
    inst.bufferSize = 20;
    inst.cursor = 10;
    inst.inputCount = 10;
    inst.echoEnabled = false;

    inst.write = writeFct;

    write_callCnt = 0u;
    write_data = 0u;
    write_length = 0u;

    utils_writeEcho(&inst, (char*)&dummyData, sizeof(dummyData));

    CHECK( write_callCnt == 0u );
    CHECK( write_data == (char*)0u );
    REQUIRE( write_length == 0u );
}
